#!/usr/bin/env -S nim c --verbosity:0 -d:release -r
import os, strutils, nre
proc org(things: varargs[string, `$`]) {.used.} =
  var output = "| "
  for thing in things:
    output &= thing & " | "
  output = output[0..^1]
  echo output
proc sub(s, reg: string, def = "NaN"): string {.used.} =
  result = def
  let m = s.find(re(reg))
  if m.isSome(): result = m.get.captures[0].strip
if paramCount() > 1:
  org "","n","els", "sum","worst","bones","vars","bvars"
  echo "|---+-----+-------+-------+------|"
for run in commandLineParams():
  var sum, worst, els = 0.0
  var bones, vars, bvars, count = 0
  let csv_path = getAppDir()/"csv"/run.strip(leading = false, chars = {'/'}).addFileExt(".csv")
  let csv = csv_path.open fmWrite
  csv.writeLine "name,path,s,b,bb,vars,bVars,first,read,bSize,bt,t,calls"
  for n in walkFiles run/"*.log":
    inc count
    let d = n.readFile
    let s = n.replace(".log", ".err").readFile.sub(" status:(.*)").strip.replace("out of ", "")
    try:
      let bt = d.sub("c(.*).*% big_search").split[0].parseFloat
      bones += d.sub("c found(.*)backbones").split[0].parseInt
      vars += d.sub("c found(.*)variables").split[0].parseInt
      if d.sub("c big_nodes (.*)").split[0] != "NaN":
        bvars += d.sub("c big_nodes (.*)").split[0].parseInt
      sum += bt
      els += d.sub("c(.*).*% big_els").split[0].parseFloat
      worst = worst.max bt
      csv.writeLine [ n.splitFile[1],
        d.sub "c array.sh: path:(.*)", " ", n.splitFile[1],
        s,
        d.sub("c found(.*)backbones").strip,
        d.sub("c found(.*)big_backbones").strip,
        d.sub("c found(.*)variables").strip,
        d.sub("c big_nodes (.*)"),
        d.sub("c(.*).*% first").split[0],
        d.sub("c(.*).*% big_read").split[0],
        d.sub("c read big with .* nodes and (.*) edges").strip,
        d.sub("c(.*).*% big_search").split[0],
        d.sub("c(.*).*% total").split[0],
        d.sub("c called solver(.*)times").split[0],
      ].join(",")
    except CatchableError: echo d.sub "c array.sh: path:(.*)", " ", n.splitFile[1]
  org run, count, els.formatFloat(ffDecimal, 2), (sum+els).formatFloat(ffDecimal, 2), worst, bones, vars, bvars
