#!/usr/bin/env python3
import sys
import matplotlib.pyplot as plt
import numpy as np
import os

def cdf(d, name):
    i = [0, 0]
    c = [0, 0]
    m = 0
    while (i[0] < len(d[0])) and (i[1] < len(d[1])):
        n = min(d[0][i[0]], d[1][i[1]])
        while (i[0] < len(d[0])) and (d[0][i[0]] <= n):
            i[0] += 1
        while (i[1] < len(d[1])) and (d[1][i[1]] <= n):
            i[1] += 1
        dif = i[1] - i[0]
        # print(dif, d[0][i[0]], d[1][i[1]])
        if dif > m:
            m = dif
            t = max(d[0][i[0]], d[1][i[1]])
    r = [0, 0]
    for e in d[0]:
        r[0] += 1
        if e > t: break
    for e in d[1]:
        r[1] += 1
        if e > t: break
    print("Maximum advantage of", r[1]/r[0], "at", t, "seconds")

    plt.plot(d[1], np.arange(len(d[1])), label='CaDiBack+KB3', zorder=4)
    plt.plot(d[0], np.arange(len(d[0])), label='CaDiBack')
    plt.xlabel('time [s]')
    plt.ylabel('backbones')
    plt.title(name)
    plt.legend()
    # plt.show()
    plt.savefig('../paper/SC2020-SC2022.pdf')
    plt.close ()

def compare(base, big, name):
    d = [[], []]
    for i, path in enumerate([base, big]):
        os.system('unxz -k ' + path)
        path = path.replace('.xz', '')
        with open(path, 'r') as file:
            for line in file:
                f = float(line)
                d[i].append(f)
        os.system('rm ' + path)
    cdf(d, name)

compare('0.1.61_CaDiBack.txt.xz', '0.1.61_CaDiBack_KB3.txt.xz', 'SC2020-SC2022')
