#!/usr/bin/env nimcr
include "pre.nim"
import threadpool
import random
randomize()

const conf = [
  ("BBE_BFS", "-n -v --big --big-only"),
  ("BBE_BFS_ELS", "-n -v --big --big-only --big-els"),
  ("BBE_BFS_ELS_ROOT", "-n -v --big --big-only --big-els"),
  ("BBE_BFS_ELS_ROOT_UIP", "-n -v --big --big-only --big-els --big-uip"),
  ("BBE_DFS", "-n -v --big --big-only --big-dfs"),
  ("BBE_DFS_ELS", "-n -v --big --big-only --big-dfs --big-els"),
  ("BBE_DFS_ELS_ROOT", "-n -v --big --big-only --big-dfs --big-els"),
  ("SUREBE_BFS", "-n -v --big --big-only --big-naive"),
  ("SUREBE_BFS_ELS", "-n -v --big --big-only --big-naive --big-els"),
  ("SUREBE_BFS_ELS_ROOT", "-n -v --big --big-only --big-naive --big-els"),
  ("SUREBE_BFS_STAMP", "-n -v --big --big-only --big-naive --big-stamp"),
  ("SUREBE_BFS_ELS_STAMP", "-n -v --big --big-only --big-naive --big-els --big-stamp"),
  ("SUREBE_BFS_ELS_ROOT_STAMP", "-n -v --big --big-only --big-naive --big-els --big-stamp"),
  ("SUREBE_DFS", "-n -v --big --big-only --big-naive --big-dfs"),
  ("SUREBE_DFS_ELS", "-n -v --big --big-only --big-naive --big-dfs --big-els"),
  ("SUREBE_DFS_ELS_ROOT", "-n -v --big --big-only --big-naive --big-dfs --big-els"),
  ("SUREBE_DFS_STAMP", "-n -v --big --big-only --big-naive --big-dfs --big-stamp"),
  ("SUREBE_DFS_ELS_STAMP", "-n -v --big --big-only --big-naive --big-dfs --big-els --big-stamp"),
  ("SUREBE_DFS_ELS_ROOT_STAMP", "-n -v --big --big-only --big-naive --big-dfs --big-els --big-stamp"),
]
temp_setup
fuzz:
  let f = temp_id()&".cnf"
  # lmd &"cnfuzz --tiny > {f}"
  lmd &"cnfuzz > {f}"
  let (n, c) = sample conf
  let back = &"../cadiback -c {c}"
  let r = smd &"{back} {f}"
  if r notin [10, 20]:
    let b = "bug_"&n&"_"&f.extractFilename
    f.copyFile b
    echo b
    let d = "red_"&n&"_"&f.extractFilename
    let e = "run_"&n&"_"&f.extractFilename
    e.writeFile "#!/bin/bash\n" & back & " $*"
    lmd &"chmod +x {e}"
    lmd &"cnfdd {b} {d} ./{e}"
    e.writeFile "#!/bin/bash\n" & back & " -l --big-draw " & d
    echo e
    break
  removeFile f
sync()

# Local Variables:
# run: "nim c --verbosity:0 -d:release --threads:on -r fuzz.nim"
# End:
